import { scaleOrdinal } from 'd3';

const features = ['Sepal L', 'Sepal W', 'Petal L', 'Petal W'];

// const colorScale = scaleOrdinal()
// 	.domain(['selected', 'unselected'])
// 	.range(['#1a46ad', '#9ec3ff']);

const selectedColor = ['#292929', 'white'];
const unselectedColor = ['#cccccc', 'black'];

const xPos = (d, i) => i % 2 * 90 + 8;
const yPos = (d, i) => parseInt(i / 2) * 50 + (parseInt(i / 4) + 1) * 40;
const xTextPos = (d, i) => i % 2 * 90 + 50;
const yTextPos = (d, i) => parseInt(i / 2) * 50 + (parseInt(i / 4) * 0.55 + 1) * 70.5;
const buttonW = 85;
const buttonH = 45;
const r = 20;

export const buttonPanel = (selection, props) => {
  const {
    buttons,
    startX,
    startY,
    onClick,
    selectedX,
    selectedY,
    data
  } = props;
  
  const rects = selection.selectAll('rect')
    .data(buttons, d => d.id);
  rects
    .enter().append('rect')
      .attr('transform', `translate(${startX}, ${startY})`)
  		.attr('x', xPos)
  		.attr('y', yPos)
  		.attr('width', buttonW)
  		.attr('height', buttonH)
  		.attr('rx', r)
    .merge(rects)
      .attr('fill', unselectedColor[0])
  		.attr('fill', d => {
    		if (d.id == selectedX | d.id === selectedY) {return selectedColor[0]}
    		else {return unselectedColor[0]};
  			// d.id === selectedX
  			// ? '#1a46ad'
  			// : '#9ec3ff'
  		})
      .on('click', d => onClick(d.id, data));
  
  
  const texts = selection.selectAll('text')
    .data(buttons, d => d.id);
  texts
    .enter().append('text')
  		.attr('class', 'buttonText')
      .attr('transform', `translate(${startX}, ${startY})`)
  		.attr('x', xTextPos)
  		.attr('y', yTextPos)
  		.attr('text-anchor', 'middle')
  		.text(d => features[d.id % 4])
    .merge(texts)
      .attr('fill', unselectedColor[1])
  		.attr('fill', d => {
    		if (d.id == selectedX | d.id === selectedY) {return selectedColor[1]}
    		else {return unselectedColor[1]};
  			// d.id === selectedX
  			// ? '#1a46ad'
  			// : '#9ec3ff'
  		})
      .on('click', d => onClick(d.id, data));
}

